DAT programName byte "GraphRgb150228c", 0 ' This will let me know what program is loaded in the Prop.
CON
{{
  ******* Public Notes *******

  Written By: Duane Degn
  Initial Release: June 2013
  MIT License (Use anyway you want but give me credit.)
  
  This is a program to light RGB LEDs using '595 shift registers.   
  Make sure and use current limiting resistors on your LEDs.
  

}}
{
  ******* Private Notes *******
  Led8by8Demo121110a start work
  on 8x8 RGB LED array.
  Use H-bridge chips on anodes and high power shift registers on cathodes.
  10d Start adding RGB support to font generation.
  10g works at displaying a pattern.
  10g Doesn't turn on the bottom row as long as the other rows which causes
  the bottom row to be dim compared with other rows.
  11b Fixed dim row.
  11e I think the PWM rate is much too slow.
  11f Try to make PASM version of PWM code.
  11g Kind of works with 11c but it has a very noticable flicker.
  11h Getting better. Reduced resolution to 16 which got rid of the
  flicker. Solid colors are not solid. Orange causes red and yellow
  stripes.
  11l Works much better but only 64-bit color.
  11m Try to increase resolution. Using 125 bit resolution still looks good.
  Works with 11j.
  11m Tried with 5, 6 and 7 bits each color. 7 bits had too much flicker.
  Propbably stay with 5 bits per color.
  11n Add menu back.
  12b Text kind of scrolls but only in red and it looks like each pixel
  is three LEDs wide.
  12e still has problems with scrolling text.
  12f Text scrolling works.
  26a Switch to longs to store colors. Each color is controlled by its own
  shift register. Use code from G-35 xmas lights and WS2801 control.
  26c Didn't work. None of the LEDs lit.
  Led3ByteColor121227a revert to Led8by8Demo121116a.
  27a No changes.
  27b Change child object.
  27c Flip font upside-down.
  27c Seems to scroll okay on a single display.
  29c Seems to work with SimplyTronics display. The scrolling isn't
  quite right with the ST display yet.
  29e The scrolling looks a lot better with the ST unit. I still
  don't know how to display two characters at once on the display.
  29e Added brightness control to larger display. Also added
  "Free Design" font to ST display.
  29e works pretty well.
  29g Characters now scroll of the end of the ST display. I still
  can't get two characters on the ST display at the same time.
  29h Two characters at once seems to be working okay on the ST
  display.
  30c Add control characters to change brightness and color from
  inside a string of characters.
  130109a Start code to add more arrays to display.
  10a Works with three Arrays.
  10c works for any number of arrays in a single row.
  If more than two arrays are used the flash from the PWM is apparent.
  11a Switch to using bits when defining resolution.
  11c Is not working correctly.
  12a With:
  ZONES_WIDE = 1 
  ZONE_WIDTH = 2
  Half of a character is displayed in the bottom half of the array.
  The portion of character displayed can be either top half or
  bottom half.
  130607a Swicth back to "Led3BytePasm130109a" driver and program
  is beginning to work. Text is displayed but the colors are wrong.
  07e Flip anodes in LED driver.
  07f Program kind of works. Rainbow text has problems.
  08a Fixed column buffer problem.
  08b Comment out a bunch of debug statements.
  08c Switch to single menu. No submenus for now.
  08d Add scroll speed control. Added pattern back as an option.
  08f Add a couple of more features.
  08g Clean up child object a bit. Still works.
  08h Save as Led3ByteColor130608hP remove most of the commented out code.
  08i Added GraphKeyboard method.
  09a Try different child object. Child object changes successful.
  09b Make changes to start to use new child object. Seems to work okay.
  09c Test with new child object. Still works.
  10a Resolution change is working but not I still can't change the number
  of active arrays. Only when "activeArrays" equals two do the arrays display
  correctly.
  10b Make changes in arrays number only affect child oject to see where problem
  lies. I think the problem is probably in this top object.
  10b Wrong way to diagnose problem. Both parent and child need to agree on
  buffer size (row size).
  10c Fixed problem with buffer size when changing number of arrays.
  10c Pattern doesn't display correctly since the pattern was designed for two
  arrays.
  10d Things are working pretty well. The pattern method still has a bug but by
  moving "messageBuffer" from after "resizedPattern" to before it, has masked the
  problem.
  I think there's a waitcnt error somewhere when transitioning from displaying
  the pattern or pulsing the arrays to text mode. There is often a longer than
  expected delay when making these transitions.
  10e Add some eye patterns.
  10f Move all eyes so they start top left of bit map. Add adjustment array.
  11a Change the way a buffer is filled with color.
  11a Works but none of the eye methods are called.
  11c "FindEyeSize" method now works correctly.
  11d Eyes kind of work. Eye modes can't be changed without leaving current eye mode.
  11d Eye positions are not correct yet.
  12b Eye mode seems to work correctly.
  12c Try different child object.
  12c Seems to work. The child object no longer pokes data into PASM code prior to launch.
  12d Try to change resolution without restarting cog.
  150228a Change name from "Led3ByteColor130619a" to "GraphRgb150228a".
  28a Change to child object.
  
} 
CON

  'DEFAULT_LED_FREQUENCY = 1000
  'STEPS_TO_PULSE = DEFAULT_RESOLUTION_BITS
  DATA_RESOLUTION = 256
  STACK_SIZE = 100
  BAUD = 115_200
  PSEUDO_MULTIPLIER = 1000
  'NUMBER_OF_RGB_LEDS = DISPLAY_PIXELS
  'DISPLAY_BYTES = NUMBER_OF_RGB_LEDS * 3

  DEFAULT_SHORT_PAUSE = 100
  BUFFER_DUMP_COLUMNS = 32
  TITLE_X = 3                   ' Location for title
  TITLE_Y = 1
 
  MODE_DISPLAY_X = TITLE_X '+ 11               
  MODE_DISPLAY_Y = TITLE_Y + 4
  ACTIVE_COLOR_DISPLAY_X = TITLE_X '+ 15               
  ACTIVE_COLOR_DISPLAY_Y = MODE_DISPLAY_Y + 1
  ACTIVE_LEDS_DISPLAY_X = TITLE_X '+ 14               
  ACTIVE_LEDS_DISPLAY_Y = ACTIVE_COLOR_DISPLAY_Y + 1
  ACTIVE_BRIGHTNESS_DISPLAY_X = TITLE_X '+ 20              
  ACTIVE_BRIGHTNESS_DISPLAY_Y = ACTIVE_LEDS_DISPLAY_Y + 1
  SPEED_DISPLAY_X = ACTIVE_BRIGHTNESS_DISPLAY_X
  SPEED_DISPLAY_Y = ACTIVE_BRIGHTNESS_DISPLAY_Y + 1
  RESOLUTION_DISPLAY_X = TITLE_X                
  RESOLUTION_DISPLAY_Y = SPEED_DISPLAY_Y + 1
  ACTIVE_ARRAYS_DISPLAY_X = TITLE_X                
  ACTIVE_ARRAYS_DISPLAY_Y = RESOLUTION_DISPLAY_Y + 1
  MENU_DISPLAY_X = TITLE_X                
  MENU_DISPLAY_Y = ACTIVE_ARRAYS_DISPLAY_Y + 2
  'METHOD_MESSAGE_DISPLAY_X = MENU_DISPLAY_X
  'METHOD_MESSAGE_DISPLAY_Y = MENU_DISPLAY_Y + 18
  TEMP_DISPLAY_X = TITLE_X                
  TEMP_DISPLAY_Y = MENU_DISPLAY_Y + 35
  
  BUFFER_DUMP_Y = TEMP_DISPLAY_Y
  MAX_DEBUG_Y = 50
  DEBUG_X = 80
  CLEARED_DEBUG_LINES = 5
  
  #0, FORWARD, BACKWARD

  COUNTER_CLOCKWISE = FORWARD
  CLOCKWISE = BACKWARD
  
  ' color enumeration tri color LEDs
  #0, BLACK, RED, ORANGE, YELLOW, GREEN, BLUE, VIOLET, WHITE, CYAN, INDIGO, CUSTOM_COLOR, RAINBOW

  FIRST_RAINBOW_COLOR = RED
  LAST_RAINBOW_COLOR = VIOLET

  #0, RED_PORTION, GREEN_PORTION, BLUE_PORTION


  ' menuMode enumeration
  #0, MAIN_MENU, COLOR_MENU, NUMBER_MENU, TEXT_MENU, MESSAGE_MENU{, 
     CHOOSE_CONFIRM_MESSAGE, CHOOSE_TEXT_COLOR}

  ' ledType enumeration (only RGB LEDs are currently supported in this program)
  #1, SINGLE_COLOR, BI_COLOR, TRI_COLOR
    ' I plan to add support for monochromatic LEDs but I don't presently
    ' have plans to support BI_COLOR LEDs.

  ' activeFont enumeration
  '#0, FREE_DESIGN_FONT

  
CON

  ARRAY_WIDTH_PIXELS = 8
  ARRAY_HEIGHT = Led#ANODE_PINS '8
  ZONES_WIDE = Led#ARRAYS_USED
  DEFAULT_ACTIVE_ARRAYS = Led#ARRAYS_USED
  ARRAYS_WIDE = ZONES_WIDE * ZONE_WIDTH
  DEFAULT_WIDTH_PIXELS = ARRAYS_WIDE * ARRAY_WIDTH_PIXELS ' 16
  DISPLAY_WIDTH_BYTES = DEFAULT_WIDTH_PIXELS * TRI_COLOR
  DISPLAY_HEIGHT = ARRAYS_HIGH * ARRAY_HEIGHT
  MAX_DISPLAY_HEIGHT_INDEX = DISPLAY_HEIGHT- 1
  DEFAULT_DISPLAY_BYTES = DISPLAY_WIDTH_BYTES * DISPLAY_HEIGHT
  PATTERN_SIZE = ARRAY_WIDTH_PIXELS * TRI_COLOR * ARRAY_HEIGHT * 2
  ARRAYS_HIGH = 1            '' Do not change these constants.
  DEFAULT_RESOLUTION_BITS = Led#BITS_OF_RESOLUTION '3 ' 5
  ZONE_WIDTH = 1
  ZONES = ZONES_WIDE * ARRAYS_HIGH 
  MAX_ALLOWED_ARRAYS = 8 ' This will determine buffer sizes. If you increase this number
                         ' use "F8" to make sure you have some spare memory.
                         ' Each possible array uses 108 longs of memory.
  MIN_ALLOWED_ARRAYS = 1
  MAX_ALLOWED_WIDTH_PIXELS = ARRAY_WIDTH_PIXELS * MAX_ALLOWED_ARRAYS
  MAX_ALLOWED_BYTES_WIDTH = MAX_ALLOWED_WIDTH_PIXELS * TRI_COLOR
  MAX_ALLOWED_DISPLAY_BYTES = MAX_ALLOWED_BYTES_WIDTH * DISPLAY_HEIGHT 
  MAX_ALLOWED_PIXELS = MAX_ALLOWED_WIDTH_PIXELS  * DISPLAY_HEIGHT
 
  ' Only three arrays may be used without flicker.
  ' LED resolution maybe 16 if only two arrays are
  ' used. Three arrays with 8 resolution seems to work.
  ' Four arrays will flicker at any resolution.

  DEFAULT_MAX_BRIGHTNESS = $FF              '' user changeable 
 
  DEFAULT_PRESS_PER_LED = 1

CON

  DEFAULT_BRIGHTNESS = $FF      '' user changeable
  DEFAULT_INTERVAL = 600_000    '' in milliseconds user changeable
  DEFAULT_DATA_PER_LED = 1      '' user changeable
                                                                                                                                                                  
VAR

  long ledStack[STACK_SIZE]
  long oneSecond, millisecond
  long displayBufferPtr
  
  byte forceColumnFlag
  
OBJ

  Led : "Led3BytePasm150228a"                       ' uses a cog
   
PUB Start(data, clock, latch, firstAnode, dataPtr, columnColorsPtr, {
} displayBufferPtr_) | localIndex, localCharacter, count, colorIndex1, colorIndex2, colorIndex3
'' uses two cogs
     
  oneSecond := clkfreq
  millisecond := clkfreq / 1000
  
  displayBufferPtr := displayBufferPtr_
  cognew(GraphLeds(data, clock, latch, firstAnode, dataPtr, {
  } columnColorsPtr), @ledStack)
  result := @ledStack
  
PRI GraphLeds(data, clock, latch, firstAnode, dataPtr, columnColorsPtr) : previousDataValue | {
} dataThisColumn, pDataThisColumn, columnTimer, msCount
 
  Led.Start(firstAnode, clock, latch, data, displayBufferPtr) 

  pDataThisColumn := -1 'make the first reading updates column
  columnTimer := cnt
  msCount := 0
  
  repeat
    dataThisColumn := long[dataPtr] - previousDataValue
    
    if dataThisColumn <> pDataThisColumn or forceColumnFlag
      pDataThisColumn := dataThisColumn
      LoadColumn(dataThisColumn, columnColorsPtr)
      if forceColumnFlag
        ScrollDisplay
        columnTimer := cnt
        msCount := 0
        forceColumnFlag := 0
        previousDataValue += dataThisColumn
    if cnt - columnTimer > millisecond
      msCount++
      columnTimer += millisecond
      if msCount == scrollInterval
        ScrollDisplay
        msCount := 0
        previousDataValue += dataThisColumn
        
PRI LoadColumn(dataThisColumn, columnColorsPtr) : rowIndex | destinationPtr

  rowIndex := dataThisColumn / dataPerLed
  
  if dataThisColumn // dataPerLed
    dataThisColumn := rowIndex + 1
  else
    dataThisColumn := rowIndex
    
  destinationPtr := displayBufferPtr + displayBytes - TRI_COLOR
  
  repeat rowIndex from 0 to MAX_DISPLAY_HEIGHT_INDEX
    if dataThisColumn > rowIndex
      AdjustBrightness(destinationPtr, columnColorsPtr, brightness)
    else
      AdjustBrightness(destinationPtr, @background, brightness)
    columnColorsPtr += TRI_COLOR
    destinationPtr -= displayWidthBytes
    
PRI AdjustBrightness(destinationPtr, sourcePtr, localBrightness)

  repeat 3
    byte[destinationPtr++] := byte[sourcePtr++] * localBrightness / 255
    
PUB ChangeDataPerLed(newDataPerLed)
'' Set new dataPerLed.
'' Returns the previous dataPerLed.

  result :=  dataPerLed
  dataPerLed := newDataPerLed

PUB ChangeInterval(newIntervalMs)
'' Set new scroll interval in milliseconds.
'' Returns the previous interval.

  result :=  scrollInterval
  scrollInterval := newIntervalMs

PUB ChangeBrightness(newBrightness)
'' Set brightness.
'' Returns the previous brightness.
'' The new brightness level will only
'' be used on future columns.

  result :=  brightness
  brightness := newBrightness

PUB ChangeBackground(newBackgroundPtr)
'' Set new background.
'' "newBackgroundPtr" should point to
'' three bytes to be used as the new
'' background color.

  bytemove(@background, newBackgroundPtr, TRI_COLOR)

PUB ForceColumn

  forceColumnFlag := 1

PUB ScrollDisplay

  ScrollSpace(1)
  
PUB ScrollSpace(localSize) | dataToScrollIndex, displayRowIndex, firstByteOfRowPtr, lastOfRowIndex
 
  localSize--
  repeat dataToScrollIndex from 0 to localSize
    repeat displayRowIndex from 0 to MAX_DISPLAY_HEIGHT_INDEX
      firstByteOfRowPtr := displayBufferPtr + (displayRowIndex * displayWidthBytes)
      lastOfRowIndex := (displayRowIndex * displayWidthBytes) + {
        } displayWidthBytes - TRI_COLOR
      bytemove(firstByteOfRowPtr, firstByteOfRowPtr + TRI_COLOR, displayWidthBytes - TRI_COLOR)
      bytemove(displayBufferPtr + lastOfRowIndex, @background, TRI_COLOR)

DAT

displayWidthPixels      long DEFAULT_WIDTH_PIXELS
displayWidthBytes       long DISPLAY_WIDTH_BYTES
displayBytes            long DEFAULT_DISPLAY_BYTES
resolution              long DEFAULT_RESOLUTION_BITS
activeArrays            long DEFAULT_ACTIVE_ARRAYS
brightness              long DEFAULT_BRIGHTNESS
scrollInterval          long DEFAULT_INTERVAL
dataPerLed              long DEFAULT_DATA_PER_LED

background              byte 0, 0, 0
                